﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi04_feherje
{
    class erettsegi04_feherje
    {
        struct aminosav
        {
            public string név;
            public char jel;
            public int c, h, o, n, s;
            public int tömeg { get { return c * 12 + h + o * 16 + n * 14 + s * 32; } }
        }

        static void Main()
        {
            #region 1. feladat: aminosav.txt file feldolgozása
            Console.WriteLine("1. Feladat: Az aminosav.txt file feldolgozása");
            List<aminosav> savak = new List<aminosav>(); //Ebben a listában tároljuk az aminósavakat
            using (StreamReader sr = new StreamReader("aminosav.txt"))
            {
                while (!sr.EndOfStream)
                {
                    aminosav új = new aminosav()
                    {
                        név = sr.ReadLine(),
                        jel = Char.Parse(sr.ReadLine()), //vagy új.jel = sr.ReadLine()[0];
                        c = int.Parse(sr.ReadLine()),
                        h = int.Parse(sr.ReadLine()),
                        o = int.Parse(sr.ReadLine()),
                        n = int.Parse(sr.ReadLine()),
                        s = int.Parse(sr.ReadLine()),
                    };
                    savak.Add(új);
                }
            }
            #endregion

            #region 2. feladat: Aminósavak relatív mulekulatömegének meghatározása:
            Console.WriteLine("\n2. Feladat: Aminósavak relatív mulekulatömegének meghatározása:");
            //Property segítségével, lsd. struktúrában
            #endregion

            #region 3. feladat: Rendezés
            //FileStream a kiíráshoz
            using (StreamWriter sw = new StreamWriter("eredmeny.txt"))
            {
                Console.WriteLine("\n3. Feladat: Rendezés");
                sw.WriteLine("\n3. Feladat: Rendezés");

                var rend_savak = from i in savak
                                 orderby i.tömeg
                                 select i;

                foreach (aminosav i in rend_savak)
                {
                    Console.WriteLine("{0} {1}", i.név, i.tömeg);
                    sw.WriteLine("{0} {1}", i.név, i.tömeg);
                }
            #endregion

            #region 4. feladat: BSA
                Console.WriteLine("\n4. Feladat: BSA");
                sw.WriteLine("\n4. Feladat: BSA");
                List<char> bsa = new List<char>();

                using (StreamReader sr = new StreamReader("bsa.txt"))
                {
                    while (!sr.EndOfStream) bsa.Add(char.Parse(sr.ReadLine()));
                }

                var bsa_linq = from i in bsa
                               join j in savak on i equals j.jel //végre egy join :-)
                               select j;

                    int cdb = bsa_linq.Sum(i => i.c);
                    int hdb = bsa_linq.Sum(i => i.h);
                    int odb = bsa_linq.Sum(i => i.o);
                    int ndb = bsa_linq.Sum(i => i.n);
                    int sdb = bsa_linq.Sum(i => i.s);

                    odb -= (bsa.Count - 1); 
                    hdb -= 2 * (bsa.Count - 1);

                    sw.WriteLine("C {0} H {1} O {2} N {3} S {4}", cdb, hdb, odb, ndb, sdb);
                    Console.WriteLine("C {0} H {1} O {2} N {3} S {4}", cdb, hdb, odb, ndb, sdb);
                
                #endregion

                #region 5. feladat: Szakításos
                Console.WriteLine("\n5. Feladat: Szakításos");
                sw.WriteLine("\n5. Feladat: Szakításos");

                int hakt = 0; //aktuális fehérjeszakasz hosszát méri
                int hmax = 0; //maximális fehérjeszakasz hossza
                int kezd = 0; //a maximális hosszhoz tartozó kezdő pozició az eredeti láncban
                int veg = 0; //a maximális hosszhoz tartozó befejező pozició az eredeti láncban
                char[] szaminosavak = { 'Y', 'W', 'F' };

                for (int i = 0; i < bsa.Count; i++)
                {
                    hakt++;
                    if (szaminosavak.Contains(bsa[i]))//szakad a lánc
                    {
                        if (hakt > hmax) //maximum keresés
                        {
                            hmax = hakt;
                            veg = i;
                        }
                        hakt = 0; //szakadt a lánc, a következő szakasz számlálásához nullázunk
                    }
                }
                kezd = veg - hmax + 1; //kezdet meghatározása az ismert adatokból 
                Console.WriteLine("maximális hossz: {0}, kezdet helye: {1}, vége: {2}", hmax, kezd+1, veg+1);
                sw.WriteLine("maximális hossz: {0}, kezdet helye: {1}, vége: {2}", hmax, kezd+1, veg+1);
                #endregion

                #region 6. feladat: Szakításos 2.
                Console.WriteLine("\n6. Feladat: Szakításos 2.");
                sw.WriteLine("\n6. Feladat: Szakításos 2.");

                int ciszteindb = 0; //itt számoljuk a Cisztein-eket

                for (int i = 0; i < bsa.Count; i++) //első hasítás keresése
                {
                    if (bsa[i] == 'C') ciszteindb++;
                    if (bsa[i] == 'R' && (bsa[i + 1] == 'A'
                        || bsa[i + 1] == 'V')) break;
                }
                Console.WriteLine("Az első hasításig {0} darab Cisztein van!", ciszteindb);
                sw.WriteLine("Az első hasításig {0} darab Cisztein van!", ciszteindb);
            }//Using sw...
                #endregion

            Console.ReadKey();
        }
    }
}